VTK: vtkSliceCubes Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkSliceCubes Class Reference

generate isosurface(s) from volume four slices at a time More...

`#include <vtkSliceCubes.h>`

Inheritance diagram for vtkSliceCubes:
[legend]
Collaboration diagram for vtkSliceCubes:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkSliceCubes * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Write ()
void | Update ()
virtual void | SetReader (vtkVolumeReader *)
| Set/get object to read slices. More...
virtual vtkVolumeReader * | GetReader ()
| Set/get object to read slices. More...
| vtkSetFilePathMacro (FileName)
| Specify file name of marching cubes output file. More...
| vtkGetFilePathMacro (FileName)
| Specify file name of marching cubes output file. More...
virtual void | SetValue (double)
| Set/get isosurface contour value. More...
virtual double | GetValue ()
| Set/get isosurface contour value. More...
| vtkSetFilePathMacro (LimitsFileName)
| Specify file name of marching cubes limits file. More...
| vtkGetFilePathMacro (LimitsFileName)
| Specify file name of marching cubes limits file. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkSliceCubes * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkSliceCubes * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkSliceCubes ()
| ~vtkSliceCubes () override
void | Execute ()
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkVolumeReader * | Reader
char * | FileName
double | Value
char * | LimitsFileName
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

generate isosurface(s) from volume four slices at a time

vtkSliceCubes is a special version of the marching cubes filter. Instead of ingesting an entire volume at once it processes only four slices at a time. This way, it can generate isosurfaces from huge volumes. Also, the output of this object is written to a marching cubes triangle file. That way, output triangles do not need to be held in memory.

To use vtkSliceCubes you must specify an instance of vtkVolumeReader to read the data. Set this object up with the proper file prefix, image range, data origin, data dimensions, header size, data mask, and swap bytes flag. The vtkSliceCubes object will then take over and read slices as necessary. You also will need to specify the name of an output marching cubes triangle file.

Warning
  This process object is both a source and mapper (i.e., it reads and writes data to a file). This is different than the other marching cubes objects (and most process objects in the system). It's specialized to handle very large data.
  This object only extracts a single isosurface. This compares with the other contouring objects in vtk that generate multiple surfaces.
  To read the output file use vtkMCubesReader.

See also
  vtkMarchingCubes vtkContourFilter vtkMCubesReader vtkDividingCubes vtkVolumeReader

Tests:
  vtkSliceCubes (Tests)

Definition at line 49 of file vtkSliceCubes.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkSliceCubes::Superclass

Definition at line 53 of file vtkSliceCubes.h.

## Constructor & Destructor Documentation

## ◆ vtkSliceCubes()

vtkSliceCubes::vtkSliceCubes | ( |  | ) |
| protected

## ◆ ~vtkSliceCubes()

vtkSliceCubes::~vtkSliceCubes | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkSliceCubes* vtkSliceCubes::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkSliceCubes::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkSliceCubes::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkSliceCubes* vtkSliceCubes::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSliceCubes::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkSliceCubes* vtkSliceCubes::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkSliceCubes::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ Write()

void vtkSliceCubes::Write | ( |  | ) |
| inline

Definition at line 57 of file vtkSliceCubes.h.

## ◆ Update()

void vtkSliceCubes::Update | ( |  | ) |

## ◆ SetReader()

virtual void vtkSliceCubes::SetReader | ( | vtkVolumeReader * |  | ) |
| virtual

Set/get object to read slices.

## ◆ GetReader()

virtual vtkVolumeReader* vtkSliceCubes::GetReader | ( |  | ) |
| virtual

Set/get object to read slices.

## ◆ vtkSetFilePathMacro() [1/2]

vtkSliceCubes::vtkSetFilePathMacro | ( | FileName |  | ) |

Specify file name of marching cubes output file.

## ◆ vtkGetFilePathMacro() [1/2]

vtkSliceCubes::vtkGetFilePathMacro | ( | FileName |  | ) |

Specify file name of marching cubes output file.

## ◆ SetValue()

virtual void vtkSliceCubes::SetValue | ( | double |  | ) |
| virtual

Set/get isosurface contour value.

## ◆ GetValue()

virtual double vtkSliceCubes::GetValue | ( |  | ) |
| virtual

Set/get isosurface contour value.

## ◆ vtkSetFilePathMacro() [2/2]

vtkSliceCubes::vtkSetFilePathMacro | ( | LimitsFileName |  | ) |

Specify file name of marching cubes limits file.

The limits file speeds up subsequent reading of output triangle file.

## ◆ vtkGetFilePathMacro() [2/2]

vtkSliceCubes::vtkGetFilePathMacro | ( | LimitsFileName |  | ) |

Specify file name of marching cubes limits file.

The limits file speeds up subsequent reading of output triangle file.

## ◆ Execute()

void vtkSliceCubes::Execute | ( |  | ) |
| protected

## Member Data Documentation

## ◆ Reader

vtkVolumeReader* vtkSliceCubes::Reader
| protected

Definition at line 99 of file vtkSliceCubes.h.

## ◆ FileName

char* vtkSliceCubes::FileName
| protected

Definition at line 100 of file vtkSliceCubes.h.

## ◆ Value

double vtkSliceCubes::Value
| protected

Definition at line 101 of file vtkSliceCubes.h.

## ◆ LimitsFileName

char* vtkSliceCubes::LimitsFileName
| protected

Definition at line 102 of file vtkSliceCubes.h.

The documentation for this class was generated from the following file:

- Imaging/Hybrid/vtkSliceCubes.h